/*

                Cۏ̎WƋL^

	Copyrights 2011,  Yoshi Hiroshi.

 */

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include <stdio.h>
#include <util/delay.h>
#include "ecr1264.h"
#include "i2cTinySht.h"
#include "spiSCP1000.h"
#include "simpleUart.h"
#include "rtc4543.h"

volatile char timerCounter;
volatile unsigned char timerMode;
volatile unsigned char sleepMode;
volatile long humidityVal;
volatile long  temperatureVal;
volatile long pressureVal;
unsigned char dateTime[7] = { 0x00, 0x00, 0x00, 0x05, 0x01, 0x01, 0x11};


//--------------------------------------------------
//
//
//
//--------------------------------------------------
void startMeasure()
{
    if(PINB & _BV(PB1)) {
        temperatureVal = scpReadTemperature();
        pressureVal = scpReadPressure();
    }
    shtStartMeassure();     // xvJn
    scpWrite(0x03, 0x0C);   // CvJn
    getDatetime(dateTime);
    SHT_COMPLETE_INT_ON;    // xv݋
}

//--------------------------------------------------
//
//
//
//--------------------------------------------------
void timerControl()
{
    if(timerCounter == 1) {
        timerMode = TIMER_1S_MODE_STARRT_SEQ;
    } else if(timerCounter == 12) {
        TIMER2_SET_SLOW;    // interval = 8sec
//    } else if(timerCounter == 18) { // 1min͐lms
//    } else if(timerCounter == 33) { // 3min͐lms
    } else if(timerCounter == (32+12)) { // 268sec(4.5min)͐lms
        CLEAR_REFRESH_REQ;
    } else  if(timerCounter >= (36+12)) { // >= 5ȏo߂ƁAlmŌvE\
        timerCounter = 99;
        if(REFRESH_REQ) 
        {
            timerCounter = 0;
            CLEAR_REFRESH_REQ;
            TIMER2_SET_FAST;    // interval = 1 sec
        }
    }
}

//--------------------------------------------------
//
//
//
//--------------------------------------------------
void collectionControl()
{
    if(timerMode > TIMER_1S_MODE_IDLE) {
        timerMode++;
        switch(timerMode) {
        case TIMER_1S_MODE_START_POWER:
            ECR_POWER_ON;
            break;
        case TIMER_1S_MODE_START_MEASURE:
            startMeasure();
            break;
        case TIMER_1S_MODE_DISP_VALUES:
            PRR &= ~_BV(PRUSART0);  // USART Power On
            UCSR0B |= _BV(TXEN0);
            DDRD |= _BV(PD1);       // USART TxD Out Enable
            showResult(temperatureVal, humidityVal, pressureVal, dateTime);
            _delay_ms(2);           // USART̓]҂B
            break;
        case TIMER_1S_MODE_WAIT_OFF:
            ECR_POWER_OFF;
            UCSR0B &= ~_BV(TXEN0);
            PRR |= _BV(PRUSART0);   // USART Power Off
            DDRD &= ~_BV(PD1);      // USART TxD Out Disable
            PORTD &= ~_BV(PD1);
            timerMode = TIMER_1S_MODE_IDLE;
            sleepMode = SLEEP_MODE_PWR_SAVE;
            break;
        default:
            break;
        }
    } else {
            ECR_POWER_OFF;
            UCSR0B &= ~_BV(TXEN0);
            PRR |= _BV(PRUSART0);   // USART Power Off
            DDRD &= ~_BV(PD1);      // USART TxD Out Disable
            PORTD &= ~_BV(PD1);
    }
}

//--------------------------------------------------
//
//      PB1:SCP1000 DRDY
//      PB0:PaPURs Sense
//
//--------------------------------------------------
ISR(PCINT0_vect)
{
    SET_SCP_INT;
}

//--------------------------------------------------
//
//      PC1:SW1
//      PC0:SW2
//
//--------------------------------------------------
ISR(PCINT1_vect)
{
}

//--------------------------------------------------
//
//      PD4: SHT11 SDA
//
//--------------------------------------------------
ISR(PCINT2_vect)
{
    SET_SHT_INT;
}

//--------------------------------------------------
//
//
//
//--------------------------------------------------
ISR(TIMER2_OVF_vect)
{
    SET_TIMER_INT;
}

//--------------------------------------------------
//
//      Main Routine
//
//--------------------------------------------------
int main()
{
    PRR = 0xAD;
    initUart();
    shtInit();
    scpInit();
    initRtc();
    //putDatetime(dateTime);
    DDRD |=  _BV(PD3);                  // ECR1264 Power Control
    PCMSK1 |= _BV(PCINT9) | _BV(PCINT8);
    PCICR = _BV(PCIE2) | _BV(PCIE1) | _BV(PCIE0);    // SHT/SCP interrupt
    PORTC |= 0x03;                      // pullup
    timerCounter = 0;
    sleepMode = SLEEP_MODE_PWR_SAVE;
    timerMode = TIMER_1S_MODE_IDLE;

    ASSR = _BV(AS2);                    // Asyncronous Timer
    loop_until_bit_is_clear(ASSR, TCR2BUB); // wait for sync
    TIMER2_SET_FAST;
    TIMSK2 |= _BV(TOIE2);
    sei();

    while(1)
    {
        set_sleep_mode(sleepMode);
        sleep_enable();
        sei();
        sleep_cpu();
        sleep_disable();

        if((PINC & 0x03) != 3) {
            if(timerMode != TIMER_MODE_TIMESET) {
                timerMode = TIMER_MODE_TIMESET;
                ECR_POWER_ON;
                while((PINC & 0x03) != 3);
                _delay_ms(100);
                while((PINC & 0x03) != 3);
                PRR &= ~_BV(PRUSART0);  // USART Power On
                UCSR0B |= _BV(TXEN0);
                DDRD |= _BV(PD1);       // USART TxD Out Enable
                TIMER2_SET_KEY_OPE;
            }
        }

        if(IS_TIMER_INT | REFRESH_REQ) {
            CLEAR_TIMER_INT;
            if(PINB & 0x01) SET_REFRESH_REQ;     // lmZT[`FbNBTv͍ő8bԊuB
                                                // KvȂAPB0[q20`33F̃RfTƗǂB
            if(timerMode == TIMER_MODE_TIMESET) {
                dateTimeSet(dateTime);
            } else {
                timerCounter++;
                timerControl();
                collectionControl();
            }
        }

        if(IS_SHT_INT) {
            CLEAR_SHT_INT;
            if(PCMSK2 & _BV(PCINT23)) {
                if((PIND & _BV(PD6)) == 0) {       // SHT11 v
                    SHT_COMPLETE_INT_OFF;
                    humidityVal = shtReadWord();
                    humidityVal = -400L + (405L * humidityVal) / 100L;
                }
            }
        }

        if(IS_SCP_INT) {
            CLEAR_SCP_INT;
            if(PINB & _BV(PB1)) {       // SCP1000 v
                temperatureVal = scpReadTemperature();
                pressureVal = scpReadPressure();
            }
        }
    }
}
