/*

                Cۏ̎WƋL^

	simpleUart.c

	Copyrights 2010,  Yoshi Hiroshi.

 */

#include <avr/io.h>
#include <avr/pgmspace.h>
#include <stdio.h>
#include "simpleUart.h"

int uartPutChar(char c, FILE *stream);
int uartGetChar(FILE *stream);

FILE uart = FDEV_SETUP_STREAM(uartPutChar, uartGetChar, _FDEV_SETUP_RW);

void initUart()
{
    //DDRD |= _BV(PD1);
    UCSR0C = _BV(UCSZ01) | _BV(UCSZ00);
    //UCSR0B = _BV(RXEN0) | _BV(TXEN0) | _BV(UDRIE0) | _BV(RXCIE0);// | _BV(TXCIE0);
    UCSR0B = _BV(RXEN0) | _BV(TXEN0);
    UCSR0A = _BV(U2X0);
    UBRR0 = 12;    // 1MHz/9600 baud 
// stdio
    stdout = stdin = &uart;
    stderr = &uart;
}

/**********************************************************************
 *
 *          Standart I/O Interface                  uartPutChar
 *
 *          Xg[֕1o͂
 *
 **********************************************************************/
int uartPutChar(char c, FILE *stream)
{
    loop_until_bit_is_clear(PIND, PD2); // wait until RTS is LOW
    loop_until_bit_is_set(UCSR0A, UDRE0);
    UDR0 = c;
    return 0;
}

/**********************************************************************
 *
 *          Standart I/O Interface                  uartGetChar
 *
 *          Xg[當1͂
 *
 **********************************************************************/
int uartGetChar(FILE *stream)
{
  return 0;
}


//--------------------------------------------------
//
//          Show Header 
//
//--------------------------------------------------
void showHeader(unsigned char dateTime[7])
{
    printf_P(PSTR("ER\n\r"));
    printf_P(PSTR("AP0,0\rAW'dd  hh  mm'\r"));
    printf_P(PSTR("SP1,0\rSW'467C'\r"));        //   
    printf_P(PSTR("SP3,0\rSW'3B7E'\r"));        //   
    printf_P(PSTR("SP5,0\rSW'4A2C'\r"));        //   
    printf_P(PSTR("SP6,0\rSW'244E422C446A434D'\r"));        // ̑l

    printf_P(PSTR("AP0,0\rAW'%2x'\r"), dateTime[4]);    // day
    printf_P(PSTR("AP4,0\rAW'%2X'\r"), dateTime[2]);    // hour
    printf_P(PSTR("AP8,0\rAW'%2x'\r"), dateTime[1]);    // minute

    printf_P(PSTR("RV\n\r"));
    printf_P(PSTR("AP0,1\rAW'                    '\r"));
    printf_P(PSTR("SP0,1\rSW'32394559'\r"));    // x
    printf_P(PSTR("SP4,1\rSW'3C3E4559'\r"));    // x
    printf_P(PSTR("SP8,1\rSW'35243035'\r"));    // C
    printf_P(PSTR("RC\n\r"));

    printf_P(PSTR("SP1,3\rSW'216E'\r"));        // 
    printf_P(PSTR("AP11,3\rAW'%c'\r"), 0x25);        // %
    printf_P(PSTR("AP18,3\rAW'hPa'\r"));        // hPa
}

//--------------------------------------------------
//
//          Show Result Data
//
//--------------------------------------------------
void showResult(long temp, long humid, long press, unsigned char dateTime[7])
{
    showHeader(dateTime);

// temp
    printf_P(PSTR("AP0,2\r"));
    printf_P(PSTR("AW'%2d'\r"), (int)((temp + 5) / 100));
    printf_P(PSTR("AW'.%d'\r"), (int)(((temp + 5) % 100) / 10));
// humidity
    printf_P(PSTR("AP8,2\r"));
    humid +=  5;
    printf_P(PSTR("AW'%d"), (int)(humid / 100));
    humid = humid % 100;
    printf_P(PSTR(".%d"), (int)(humid / 10));
    printf_P(PSTR("'\r"));
// pressure
    printf_P(PSTR("AP16,2\r"));
    printf_P(PSTR("AW'%4d'\r"), (int)(press / 100));

    //printf("PS4,2\r");           /*2010/02oוȍ~*/
    printf_P(PSTR("DP\r"));
}
