/*

                Cۏ̎WƋL^

	spiSCP1000.c

	SPIڑ̈̓ZT(SCP1000W[)Rg[B

	Copyrights 2010,  Yoshi Hiroshi.

 */

#include "spiSCP1000.h"
#include <util/delay.h>

//------------------------------
void scpInit()
{
    SCP_DDR |= 0x2C;
    SCP_SCK_LOW;
    SCP_CSB_HIGH;
// wait 150mS
    _delay_ms(150);
// set low noise configuration
    scpWrite(0x02, 0x2D);
    scpWrite(0x01, 0x03);
    scpWrite(0x03, 0x02);
// wait 100mS
    _delay_ms(100);
// set measurement mode
    scpWrite(0x03, 0x0C);
}

//------------------------------
unsigned char scpTransferByte(unsigned char val)
{
	unsigned char result = 0;
	for(unsigned char count = 0; count < 8; count++)
    {
        result = result << 1;
        SCP_SEND_MOSI(val & 0x80);
		SCP_SCK_HIGH;
		SCP_SCK_HIGH;
        result |= (SCP_GET_MISO ? 1 : 0);
		SCP_SCK_LOW;
        val = val << 1;
	}
	return result;
}

//------------------------------
unsigned char scpWrite(unsigned char reg, unsigned char val)
{
	unsigned char result;
    SCP_CSB_LOW;
    result = scpTransferByte((reg << 2) | (SCP_REQUEST_WRITE) << 1);
    result = scpTransferByte(val);
    SCP_CSB_HIGH;
    return result;
}

//------------------------------
unsigned char scpReadByte(unsigned char reg)
{
	unsigned char result;
    SCP_CSB_LOW;
    result = scpTransferByte(reg << 2);
    result = scpTransferByte(0);
    SCP_CSB_HIGH;
    return result;
}

//------------------------------
unsigned int scpReadWord(unsigned char reg)
{
	unsigned int result;
    SCP_CSB_LOW;
    result = scpTransferByte(reg << 2);
    result = scpTransferByte(0xFF) << 8;
    result |= scpTransferByte(0xFF);
    SCP_CSB_HIGH;
    return result;
}

//------------------------------
int scpReadTemperature()
{
    int result;
    result = scpReadWord(0x21) & 0x3FFF;
    if(result & 0x2000) {
         result |= 0xC000;
    }
    result *= 5;
    return result;
}

//------------------------------
long scpReadPressure()
{
    long result;
    result = scpReadByte(0x1F) & 0x07;
    result = (result << 16) | scpReadWord(0x20);
    result /= 4;
    return result;
}
