/*

                Cۏ̎WƋL^

	spiSCP1000.h

	SPIڑ̈̓ZT(SCP1000W[)Rg[B

	Copyrights 2010,  Yoshi Hiroshi.

 */

#include <avr/io.h>

void scpInit();
unsigned char scpTransferByte(unsigned char ack);
unsigned char scpWrite(unsigned char reg, unsigned char val);
unsigned char scpReadByte(unsigned char reg);
unsigned int scpReadWord(unsigned char reg);
int scpReadTemperature();
long scpReadPressure();

#define SCP_REQUEST_WRITE		1
#define SCP_REQUEST_READ		0

#define SCP_SCK_HIGH            {PORTB |= _BV(SCP_SCK);}
#define SCP_SCK_LOW             {PORTB &= ~_BV(SCP_SCK);}
#define SCP_CSB_HIGH            {PORTB |= _BV(SCP_CSB);}
#define SCP_CSB_LOW             {PORTB &= ~_BV(SCP_CSB);}
//#define SCP_TRIG_HIGH           {PORTB |= _BV(SCP_TRIG);}
//#define SCP_TRIG_LOW            {PORTB &= ~_BV(SCP_TRIG);}

#define SCP_GET_MISO            (PINB & _BV(SCP_MISO))
#define SCP_MOSI_HIGH           {PORTB |= _BV(SCP_MOSI);}
#define SCP_MOSI_LOW            {PORTB &= ~_BV(SCP_MOSI);}
#define SCP_SEND_MOSI(val)      {if(val) SCP_MOSI_HIGH else SCP_MOSI_LOW}

//--- Bit Assignment
#define SCP_SCK					5       // out
#define SCP_MISO				4       // in
#define SCP_MOSI				3       // out
#define SCP_CSB					2       // out
#define SCP_DRDY				1       // in
//#define SCP_TRIG				0       // out

//--- Register Assignment
#define SCP_PORT		        PORTB
#define SCP_DDR				    DDRB

